#include <tigcclib.h>

// PrimeFinder 89
// By Alexandru Margarit, May 2006
// http://www.artraid.com/alex
// artraid@gmail.com

// Learn, but never steal!

// Main Function
void _main(void)
{
	// disable interrupt for key input
	INT_HANDLER interrupt1 = GetIntVec(AUTO_INT_1);
	SetIntVec(AUTO_INT_1, DUMMY_HANDLER);
	
	// variables
	long int numbers;	
	int invalid;
	int l, l2;
	int s;
	int quit;
	
	quit = 0;
	numbers = 3;
	s = 5000;

	// clear screen and reset printf cursor
	ClrScr();
	clrscr();
	
	// instructions
	printf("PrimeFinder 68k\nBy Alexandru Margarit 2006\n\n2ND - pause\nESC - exit\nUP/DOWN - adjust speed\n\nPress 2ND to begin!");
	
	// wait to press 2ND
	while(!_keytest(RR_2ND)); while(_keytest(RR_2ND));
	
	// print the first two prime numbers
	printf("\n\n1\n2");
	
	// main loop
	while(!quit) {
		
		// premise that it is a valid prime number
		invalid = 0;
		
		// scan (odd) numbers
		for(l = 3; l < numbers; l += 2) {
			
			// quit or pause key inputs
			if(_keytest(RR_ESC)) { quit = 1; break; }
			if(_keytest(RR_2ND)) { while(_keytest(RR_2ND)); while(!_keytest(RR_2ND)); while(_keytest(RR_2ND)); }
			
			// slow/fast scrolling
			if(_keytest(RR_UP) && s == 0) s = 5000;
			else if(_keytest(RR_DOWN) && s == 5000) s = 0;
			
			// if it ever divides with remainder 0, then it is not prime - INVALID
			if(!(numbers % l)) { invalid = 1; break; }
			
			// don't scan forever
			if((int)(numbers / l) < l) break;
			
		}
		
		// an unpredictable error handling - never tested, I wasn't patient to wait for it to cycle through the ten-million primes...
		if(numbers < 3) {			
			quit = 1;
			printf("\n\nOverflow. Press 2ND!");
			while(!_keytest(RR_2ND));
		}
		
		// if it is NOT invalid, then it is prime; print it!
		if(!invalid) printf("\n%ld", numbers);
		
		// increment by two (odd numbers only)
		numbers += 2;
		
		// primitive scrolling speed delay :(
		for(l2 = 0; l2 < 10; l2++) for(l = 0; l < s; l++);
		
	}

	// enable interrupt
	SetIntVec(AUTO_INT_1, interrupt1);
}
